Uses CRT;

Const OperSet:set of char= ['+','-','*','/','(',')','^'];

Type TStack = record
            St : String[20];
            Co : Integer;
     End;

Var Stack : array [1..10] of TStack;
    InputString : String;
    OutputString : String;
    I,J,K, TopStack : Word;
    Symb : Char;
    SymbTmp : Char;

Function ChToInt(C:Char):Integer;
Var Result : Integer;
Begin
     Case C Of
          '-': Result := 3;
          '+': Result := 3;
          '*': Result := 2;
          '/': Result := 2;
          '^': Result := 1;
     Else Result := 0;
     End;
     ChToInt := Result;
End;

Procedure Push(Ch : Char);
Begin
     Inc(TopStack);
     Stack[TopStack].St := Ch;
     Stack[TopStack].Co := ChToInt(Ch);
End;

Function Max(A,B,C:Integer):Integer;
Var Tmp : Integer;
Begin
     If A > B Then Tmp := A
              Else Tmp := B;
     If Tmp > C Then Max := Tmp
                Else Max := C;
End;

Procedure Pop;
Var Tmp : Integer;
Begin
     Tmp := Max(Stack[TopStack-0].Co,
                Stack[TopStack-1].Co,
                Stack[TopStack-2].Co);

     If Stack[TopStack].Co <> Tmp Then Begin
        If Length(Stack[TopStack-2].St) <> 1 Then
           Stack[TopStack-2].St := '(' + Stack[TopStack-2].St + ')';
        If Length(Stack[TopStack-1].St) <> 1 Then
           Stack[TopStack-1].St := '(' + Stack[TopStack-1].St + ')';
     End;

     Stack[TopStack-2].Co := Tmp;

     Stack[TopStack-2].St := Stack[TopStack-2].St +
                             Stack[TopStack-0].St +
                             Stack[TopStack-1].St;

     Dec(TopStack,2);
End;

Begin
     ClrScr;
     TopStack := 0;
     OutputString := '';
     ReadLn(InputString);

     OutputString := InputString;

     For I := 1 To Length(InputString) Do Begin
         Push(InputString[I]);
         If Stack[TopStack].Co <> 0 Then Pop;
     End;

     OutputString := Stack[1].St;

     WriteLn(InputString);
     WriteLn(OutputString);
     ReadLn;
End.